//
// TiglUsb_Test.cpp : Defines the entry point for the console application.
//
// (this file is the same for both drivers (98DDK & XPDDK))

#include "stdafx.h"

#include <stdio.h>
#include <conio.h>

#include "TiglUsb.h"

#if 0

// test for API #1 (3.0)
int main(int argc, char* argv[])
{
	UCHAR data;
	int i;
	int ret = 0;
	int status = 0;

	printf("Version : %s\n", TiglUsbVersion());

	ret = TiglUsbOpen();
	if(ret)	printf("Error code = %i\n", ret);

	TiglUsbSetTimeout(15);

	ret = TiglUsbReset();
	if(ret)	printf("Error code = %i\n", ret);

	// poll for data
#if 1
	for(i=0; i<5; i++)
	{
		fprintf(stdout, "Waiting for data...\n");
		for(status = 0; !status; )
		{
			ret = TiglUsbCheck(&status);
			if(ret)	printf("TiglUsbCheck: Error code = %i\n", ret);
			if(ret) goto end;
		}

		ret = TiglUsbRead(&data);
		printf("%02X\n", data);
		if(ret) 
		{
			if(ret)	printf("Error code = %i\n", ret);
			goto end;
		}
	}
	fprintf(stdout, "Data ready !\n");

    ret = TiglUsbFlush();
	if(ret)	printf("Error code = %i\n", ret);

	goto end;
#endif

	// send an 'Is ready ?' packet
	ret = TiglUsbWrite(0x00);
	if(ret)	printf("Error code = %i\n", ret);
	if(ret) goto end;

	ret = TiglUsbWrite(0x68);
	if(ret)	printf("Error code = %i\n", ret);
	if(ret) goto end;

	ret = TiglUsbWrite(0x00);
	if(ret)	printf("Error code = %i\n", ret);
	if(ret) goto end;

	ret = TiglUsbWrite(0x00);
	if(ret)	printf("Error code = %i\n", ret);
	if(ret) goto end;

	// receive answer
	for(i=0; i<4; i++)
	{
		ret = TiglUsbRead(&data);
		printf("%02X ", data);
		if(ret) {
			if(ret)	printf("Error code = %i\n", ret);
			goto end;
		}
	}

    //ret = TiglUsbFlush();
	//if(ret)	printf("Error code = %i\n", ret);

	printf("\n");

end:

	ret = TiglUsbClose();
	if(ret)	printf("Error code = %i\n", ret);

	fprintf(stdout, "Waiting for key press...\n");
	while(!_kbhit());

	return 0;
}

#else

// test for API #2 (3.2)
int main(int argc, char* argv[])
{
	int h;
	UCHAR buf[4];
	int i;
	int ret = 0;
	int status = 0;
	PUINT list;
	UCHAR scr[3840 + 6];

	printf("Version : %s\n", TiglUsbVersion());

#if 0
	ret = TiglUsbProbe2(&list);
	for(i = 0; i < ret; i++)
		printf("%04x ", list[i]); printf("\n");
#endif

	ret = h = TiglUsbOpen2(1);
	if(ret)	printf("Error code = %i\n", ret);

	// reset device
	ret = TiglUsbReset2(h);
	if(ret)	printf("Error code = %i\n", ret);

	TiglUsbSetTimeout2(h, 15);

#if 1
	// send an 'Is ready ?' packet
	buf[0] = 0x00; buf[1] = 0x68; buf[2] = 0x00; buf[3] = 0x00;

	ret = TiglUsbWrites2(h, buf, 4);
	if(ret)	printf("Error code = %i\n", ret);
	if(ret) goto end;

	// receive answer
	ret = TiglUsbReads2(h, buf, 4);
	if(ret)	printf("Error code = %i\n", ret);
	if(ret)	goto end;

	for(i=0;i<4;i++) printf("%02x ", buf[i]); printf("\n");

	printf("\n");
#endif

#if 1
	// do a screendump
	buf[0] = 0x08;  buf[1] = 0x6D; buf[2] = 0x00; buf[3] = 0x00;	// SCR
	//buf[0] = 0x73;  buf[1] = 0x6D; buf[2] = 0x00; buf[3] = 0x00;	// SCR

	ret = TiglUsbWrites2(h, buf, 4);
	if(ret)	printf("Error code = %i\n", ret);
	if(ret) goto end;
	
	ret = TiglUsbReads2(h, buf, 4);
	if(ret)	printf("Error code = %i\n", ret);
	if(ret)	goto end;

	ret = TiglUsbReads2(h, scr, 0x0300/*0x0f00*/ + 6);
	if(ret)	printf("Error code = %i\n", ret);
	if(ret)	goto end;
	fprintf(stdout, "%02x %02x\n", scr[2], scr[3]);

	buf[0] = 0x08;  buf[1] = 0x56; buf[2] = 0x00; buf[3] = 0x00;	// ACK
	//buf[0] = 0x73;  buf[1] = 0x56; buf[2] = 0x00; buf[3] = 0x00;	// ACK
	ret = TiglUsbWrites2(h, buf, 4);
	if(ret)	printf("Error code = %i\n", ret);
	if(ret) goto end;
#endif

#if 0
	{
		fprintf(stdout, "Waiting for data...\n");
		for(status = 0; !status; )
		{
			ret = TiglUsbCheck2(h, &status);
			if(ret)	printf("TiglUsbCheck2: Error code = %i\n", ret);
			if(ret) goto end;
		}
		fprintf(stdout, "Data ready !\n");

		ret = TiglUsbReads2(h, buf, 4);
		if(ret)	printf("TiglUsbReads2: Error code = %i\n", ret);
		if(ret) goto end;

		for(i=0;i<4;i++) printf("%02x ", buf[i]); printf("\n");


		fprintf(stdout, "Waiting for data...\n");
		for(status = 0; !status; )
		{
			ret = TiglUsbCheck2(h, &status);
			if(ret)	printf("TiglUsbCheck2: Error code = %i\n", ret);
			if(ret) goto end;
		}
		fprintf(stdout, "Data ready !\n");

		ret = TiglUsbReads2(h, buf, 4);
		if(ret)	printf("TiglUsbReads2: Error code = %i\n", ret);
		if(ret) goto end;

		for(i=0;i<4;i++) printf("%02x ", buf[i]); printf("\n");
	}
#endif

end:

	ret = TiglUsbClose2(h);
	if(ret)	printf("Error code = %i\n", ret);

	fprintf(stdout, "Waiting for key press...\n");
	while(!_kbhit());

	return 0;
}

#endif